<html><head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>immatch_BruteForce</title>
    <style type="text/css" media="all">
      @import url("scilab_code.css");
      @import url("xml_code.css");
      @import url("c_code.css");
      @import url("style.css");
    </style>
  </head>
  <body>
    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="imextract_DescriptorSURF.html">&lt;&lt; imextract_DescriptorSURF</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_8792051ef89a035bfefbe098ed0172e1.html">Feature Detection, Description and Matching</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="plotfeature.html">plotfeature &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>



    <span class="path"><a href="index.html">IPCV - Image Processing and Computer Vision Toolbox for Scilab</a> &gt;&gt; <a href="section_8792051ef89a035bfefbe098ed0172e1.html">Feature Detection, Description and Matching</a> &gt; immatch_BruteForce</span>

    <br /><br />
    <div class="refnamediv"><h1 class="refname">immatch_BruteForce</h1>
    <p class="refpurpose">Brute-force matcher for features matching.</p></div>


<div class="refsynopsisdiv"><h3 class="title">Syntax</h3>
   <div class="synopsis"><pre><span class="default">m</span><span class="default"> = </span><span class="functionid">immatch_BruteForce</span><span class="default">(</span><span class="default">des1</span><span class="default">,</span><span class="default">des2</span><span class="default">,</span><span class="default">normType</span><span class="default">);</span></pre></div></div>

<div class="refsection"><h3 class="title">Parameters</h3>
   <dl><dt><span class="term">des1 :</span>
      <dd><p class="para">First descriptor</p></dd></dt>
   <dt><span class="term">des2 :</span>
      <dd><p class="para">Second descriptor</p></dd></dt>
   <dt><span class="term">normType :</span>
      <dd><p class="para">One of NORM_L1, NORM_L2, NORM_HAMMING, NORM_HAMMING2. L1 and L2 norms are preferable choices for SIFT and SURF descriptors, NORM_HAMMING should be used with ORB, BRISK and BRIEF, NORM_HAMMING2 should be used with ORB when WTA_K==3 or 4 (see ORB::ORB constructor description).</p></dd></dt>
   <dt><span class="term">m :</span>
      <dd><p class="para">Mathching matrix</p></dd></dt></dl></div>

<div class="refsection"><h3 class="title">Description</h3>
   <p class="para">This function used to Brute-force matcher to match the given descriptors.</p>
   <p class="para"></p></div>

<div class="refsection"><h3 class="title">Examples</h3>
   <div class="programlisting"><table border="0" width="100%"><tr><td width="98%"><pre class="scilabcode"><span class="scilabcomment">// Read the image and rotate it by 45 degrees</span>
<span class="scilabid">S</span> <span class="scilaboperator">=</span> <span class="scilabid">imread</span><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://fullpath">fullpath</a><span class="scilabopenclose">(</span><span class="scilabid">getIPCVpath</span><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span> <span class="scilaboperator">+</span> <span class="scilabstring">&#0034;</span><span class="scilabstring">/images/balloons_gray.png</span><span class="scilabstring">&#0034;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">S2</span> <span class="scilaboperator">=</span> <span class="scilabid">imrotate</span><span class="scilabopenclose">(</span><span class="scilabid">S</span><span class="scilabdefault">,</span><span class="scilabnumber">45</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabcomment">// Use the ORB to detect features</span>
<span class="scilabid">f1</span> <span class="scilaboperator">=</span> <span class="scilabid">imdetect_ORB</span><span class="scilabopenclose">(</span><span class="scilabid">S</span><span class="scilabopenclose">)</span>
<span class="scilabid">f2</span> <span class="scilaboperator">=</span> <span class="scilabid">imdetect_ORB</span><span class="scilabopenclose">(</span><span class="scilabid">S2</span><span class="scilabopenclose">)</span>
<span class="scilabcomment">// Extract the descriptor</span>
<span class="scilabid">d1</span> <span class="scilaboperator">=</span> <span class="scilabid">imextract_DescriptorORB</span><span class="scilabopenclose">(</span><span class="scilabid">S</span><span class="scilabdefault">,</span><span class="scilabid">f1</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">d2</span> <span class="scilaboperator">=</span> <span class="scilabid">imextract_DescriptorORB</span><span class="scilabopenclose">(</span><span class="scilabid">S2</span><span class="scilabdefault">,</span><span class="scilabid">f2</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabcomment">// Feature matching</span>
<span class="scilabid">m</span> <span class="scilaboperator">=</span> <span class="scilabid">immatch_BruteForce</span><span class="scilabopenclose">(</span><span class="scilabid">d1</span><span class="scilabdefault">,</span><span class="scilabid">d2</span><span class="scilabdefault">,</span><span class="scilabnumber">4</span><span class="scilabopenclose">)</span>
<span class="scilabcomment">// Find the 10 best matches</span>
<span class="scilabopenclose">[</span><span class="scilabid">fout1</span><span class="scilabdefault">,</span><span class="scilabid">fout2</span><span class="scilabdefault">,</span><span class="scilabid">mout</span><span class="scilabopenclose">]</span> <span class="scilaboperator">=</span> <span class="scilabid">imbestmatches</span><span class="scilabopenclose">(</span><span class="scilabid">f1</span><span class="scilabdefault">,</span><span class="scilabid">f2</span><span class="scilabdefault">,</span><span class="scilabid">m</span><span class="scilabdefault">,</span><span class="scilabnumber">10</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabcomment">// Draw the matches</span>
<span class="scilabid">SS</span> <span class="scilaboperator">=</span> <span class="scilabid">imdrawmatches</span><span class="scilabopenclose">(</span><span class="scilabid">S</span><span class="scilabdefault">,</span><span class="scilabid">S2</span><span class="scilabdefault">,</span><span class="scilabid">fout1</span><span class="scilabdefault">,</span><span class="scilabid">fout2</span><span class="scilabdefault">,</span><span class="scilabid">mout</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabcomment">// Show the comparison</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">SS</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span></pre></td><td valign="top"><a href="scilab://scilab.execexample/"><img src="ScilabExecute.png" border="0"/></a></td><td valign="top"><a href="scilab://scilab.editexample/"><img src="ScilabEdit.png" border="0"/></a></td><td></td></tr></table></div></div>

<div class="refsection"><h3 class="title">See also</h3>
   <ul class="itemizedlist"><li class="member"><a href="imbestmatches.html" class="link">imbestmatches</a></li>
   <li class="member"><a href="imdrawmatches.html" class="link">imdrawmatches</a></li></ul></div>

<div class="refsection"><h3 class="title">Authors</h3>
   <ul class="itemizedlist"><li class="member">Tan Chin Luh</li></ul></div>

<div class="refsection"><h3 class="title">Bibliography</h3>
   <p class="para">1. OpenCV 2.4 Online Documentation</p></div>
    <br />

    <div class="manualnavbar">
    <table width="100%">
    <tr><td colspan="3" class="next"><a href="http://bugzilla.scilab.org/enter_bug.cgi?product=Scilab%20software&component=Documentation%20pages" class="ulink">Report an issue</a></td></tr>
<tr>
      <td width="30%">
    	<span class="previous"><a href="imextract_DescriptorSURF.html">&lt;&lt; imextract_DescriptorSURF</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_8792051ef89a035bfefbe098ed0172e1.html">Feature Detection, Description and Matching</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="plotfeature.html">plotfeature &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>
  </body>
</html>
